#pragma once
#include "IManagerInterface.h"
#include "ServerToolWrap.h"
#include "SyncObject.h"

/*!
	C^[tF[X}l[W
*/
class CInterfaceManager
{
public:
	CInterfaceManager(void);
	virtual ~CInterfaceManager(void);

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	Jn
	void Start(CIServerToolWrap serverTool);

	//!	~
	void Stop();

	//!	C^tF[Xo^
	int RegisterInterface(CString interfaceName, IManagerInterfacePtr ifRegister, IManagerInterfacePtr *oldInterface = NULL);

	//!	C^[tF[Xo^
	int UnRegisterInterface(CString interfaceName, IManagerInterfacePtr ifUnRegister, IManagerInterfacePtr oldInterface = NULL);

	//!	C^tF[X擾
	void *GetInterface(CString interfaceName, int ifVersion);

protected:
	/////////////////////////////////////////////////////////////////////////////////
	//	⏕֐
	/////////////////////////////////////////////////////////////////////////////////
	//!	C^tF[Xo^
	int _RegisterInterface(CString interfaceName, IManagerInterfacePtr ifRegister, IManagerInterfacePtr *oldInterface = NULL);

	//!	
	int FindIndex(CString ifName);

	/////////////////////////////////////////////////////////////////////////////////
	//	NX
	/////////////////////////////////////////////////////////////////////////////////
	class CRegisterdInterface
	{
	public:
		CRegisterdInterface() {};
		CRegisterdInterface(CString interfaceName, IManagerInterfacePtr ifRegister)
		{
			m_interfaceName = interfaceName;
			m_interface = ifRegister;
		};

		//!	C^[tF[X
		CString					m_interfaceName;

		//!	C^[tF[X
		IManagerInterfacePtr	m_interface;
	};
	class CRegisterdInterfaceArray : public CArray<CRegisterdInterface> {};

	/////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	/////////////////////////////////////////////////////////////////////////////////
	//!	tO
	CInterlockCounter			m_init;

	//!	NeBJZNV
	CCriticalSection			m_scopeLock;

	//!	ۑ̃C^tF[X
	CRegisterdInterfaceArray	m_ifArray;
};

